# eiko fried, october 19 2016

# estimate network
library("qgraph")
load("data.Rda")
cormatrix <- cor_auto(data)

graph1<-qgraph(cormatrix, graph="glasso", layout="spring", sampleSize = nrow(data),
              vsize=7, cut=0, maximum=.45, border.width=1.5)

nNode <- 20
set.seed(1)
graph2<-qgraph(cormatrix, graph="glasso", layout="spring", sampleSize = nrow(data),
               vsize=7, cut=0, maximum=.45, border.width=1.5, layout.par = list(init = matrix(rnorm(nNode*2),nNode,2)))
set.seed(2)
graph3<-qgraph(cormatrix, graph="glasso", layout="spring", sampleSize = nrow(data),
               vsize=7, cut=0, maximum=.45, border.width=1.5, layout.par = list(init = matrix(rnorm(nNode*2),nNode,2)))

# eigenvalue decomposition

plot(eigen(cormatrix)$values, type="b")
abline(h=1,col="red", lty = 3)

# spinglass algorithm
library("igraph")
community.newman <- function(g) {
  deg <- degree(g)
  ec <- ecount(g)
  B <- get.adjacency(g) - outer(deg, deg, function(x,y) x*y/2/ec)
  diag(B) <- 0
  eigen(B)$vectors[,1]
}
g = as.igraph(graph1, attributes=TRUE)
sgc <- spinglass.community(g)
sgc$membership
# 5 5 5 5 5 5 5 2 3 1 1 3 3 3 4 4 2 2 3 3

# exploratory graph analysis
library("devtools")
devtools::install_github('hfgolino/EGA')
library("EGA")
ega<-EGA(data, plot.EGA = TRUE)
